> ## Documentation Index
> Fetch the complete documentation index at: https://docs.honeyhive.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a batch of events (deprecated)

> Deprecated. Use `POST /v1/events/batch` instead. The legacy route accepts the deprecated `is_single_session` and `session` aliases and lets per-event objects carry the deprecated `project` field; the v1 route rejects all three at the SDK boundary.




## OpenAPI

````yaml post /events/batch
openapi: 3.0.3
info:
  title: HoneyHive API
  version: 1.0.1
servers:
  - url: https://api.honeyhive.ai
security:
  - BearerAuth: []
paths:
  /events/batch:
    post:
      tags:
        - Events
      summary: Create a batch of events
      description: Please refer to our instrumentation guide for detailed information
      operationId: createEventBatch
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                events:
                  type: array
                  items:
                    $ref: '#/components/schemas/CreateEventRequest'
                is_single_session:
                  type: boolean
                  description: >-
                    Default is false. If true, all events will be associated
                    with the same session
              required:
                - events
      responses:
        '200':
          description: Events created
          content:
            application/json:
              schema:
                type: object
                properties:
                  event_ids:
                    type: array
                    items:
                      type: string
                  session_id:
                    type: string
                  success:
                    type: boolean
                example:
                  event_ids:
                    - 7f22137a-6911-4ed3-bc36-110f1dde6b66
                    - 7f22137a-6911-4ed3-bc36-110f1dde6b67
                  session_id: caf77ace-3417-4da4-944d-f4a0688f3c23
                  success: true
        '500':
          description: Events partially created
          content:
            application/json:
              schema:
                type: object
                properties:
                  event_ids:
                    type: array
                    items:
                      type: string
                  errors:
                    type: array
                    items:
                      type: string
                      description: >-
                        Any failure messages for events that could not be
                        created
                  success:
                    type: boolean
                example:
                  event_ids:
                    - 7f22137a-6911-4ed3-bc36-110f1dde6b66
                    - 7f22137a-6911-4ed3-bc36-110f1dde6b67
                  errors:
                    - Could not create event due to missing inputs
                    - Could not create event due to missing source
                  success: true
      x-codeSamples:
        - lang: python
          label: createEventBatch
          source: >-
            import honeyhive

            from honeyhive.models import components, operations


            s = honeyhive.HoneyHive(
                bearer_auth="<YOUR_BEARER_TOKEN_HERE>",
            )



            res =
            s.events.create_event_batch(request=operations.CreateEventBatchRequestBody(
                events=[
                    components.CreateEventRequest(
                        project='Simple RAG',
                        source='playground',
                        event_name='Model Completion',
                        event_type=components.CreateEventRequestEventType.MODEL,
                        event_id='7f22137a-6911-4ed3-bc36-110f1dde6b66',
                        session_id='caf77ace-3417-4da4-944d-f4a0688f3c23',
                        parent_id='caf77ace-3417-4da4-944d-f4a0688f3c23',
                        children_ids=[
                            '<value>',
                        ],
                        config={
                            'model': 'gpt-3.5-turbo',
                            'version': 'v0.1',
                            'provider': 'openai',
                            'hyperparameters': {
                                'temperature': 0,
                                'top_p': 1,
                                'max_tokens': 1000,
                                'presence_penalty': 0,
                                'frequency_penalty': 0,
                                'stop': [
                                    '<value>',
                                ],
                                'n': 1,
                            },
                            'template': [
                                {
                                    'role': 'system',
                                    'content': 'Answer the user\'s question only using provided context.

                                    Context: {{ context }}',
                                },
                                {
                                    'role': 'user',
                                    'content': '{{question}}',
                                },
                            ],
                            'type': 'chat',
                        },
                        inputs={
                            'context': 'Hello world',
                            'question': 'What is in the context?',
                            'chat_history': [
                                {
                                    'role': 'system',
                                    'content': 'Answer the user\'s question only using provided context.

                                    Context: Hello world',
                                },
                                {
                                    'role': 'user',
                                    'content': 'What is in the context?',
                                },
                            ],
                        },
                        outputs={
                            'role': 'assistant',
                            'content': 'Hello world',
                        },
                        error=None,
                        start_time=1714978764301,
                        end_time=1714978765301,
                        duration=999.8056,
                        metadata={
                            'cost': 0.00008,
                            'completion_tokens': 23,
                            'prompt_tokens': 35,
                            'total_tokens': 58,
                        },
                        feedback={

                        },
                        metrics={
                            'Answer Faithfulness': 5,
                            'Answer Faithfulness_explanation': 'The AI assistant\'s answer is a concise and accurate description of Ramp\'s API. It provides a clear explanation of what the API does and how developers can use it to integrate Ramp\'s financial services into their own applications. The answer is faithful to the provided context.',
                            'Number of words': 18,
                        },
                        user_properties={
                            'user': 'google-oauth2|111840237613341303366',
                        },
                    ),
                ],
            ))


            if res.object is not None:
                # handle response
                pass
        - lang: typescript
          label: createEventBatch
          source: >-
            import { HoneyHive } from "honeyhive";

            import { CreateEventRequestEventType } from
            "honeyhive/dist/models/components";


            async function run() {
              const sdk = new HoneyHive({
                bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
              });

              const res = await sdk.events.createEventBatch({
                events: [
                  {
                    project: "Simple RAG",
                    source: "playground",
                    eventName: "Model Completion",
                    eventType: CreateEventRequestEventType.Model,
                    eventId: "7f22137a-6911-4ed3-bc36-110f1dde6b66",
                    sessionId: "caf77ace-3417-4da4-944d-f4a0688f3c23",
                    parentId: "caf77ace-3417-4da4-944d-f4a0688f3c23",
                    childrenIds: [
                      "<value>",
                    ],
                    config: {
                      "model": "gpt-3.5-turbo",
                      "version": "v0.1",
                      "provider": "openai",
                      "hyperparameters": {
                        "temperature": 0,
                        "top_p": 1,
                        "max_tokens": 1000,
                        "presence_penalty": 0,
                        "frequency_penalty": 0,
                        "stop": [
                          "<value>",
                        ],
                        "n": 1,
                      },
                      "template": [
                        {
                          "role": "system",
                          "content": "Answer the user's question only using provided context.

                          Context: {{ context }}",
                        },
                        {
                          "role": "user",
                          "content": "{{question}}",
                        },
                      ],
                      "type": "chat",
                    },
                    inputs: {
                      "context": "Hello world",
                      "question": "What is in the context?",
                      "chat_history": [
                        {
                          "role": "system",
                          "content": "Answer the user's question only using provided context.

                          Context: Hello world",
                        },
                        {
                          "role": "user",
                          "content": "What is in the context?",
                        },
                      ],
                    },
                    outputs: {
                      "role": "assistant",
                      "content": "Hello world",
                    },
                    error: null,
                    startTime: 1714978764301,
                    endTime: 1714978765301,
                    duration: 999.8056,
                    metadata: {
                      "cost": 0.00008,
                      "completion_tokens": 23,
                      "prompt_tokens": 35,
                      "total_tokens": 58,
                    },
                    feedback: {

                    },
                    metrics: {
                      "Answer Faithfulness": 5,
                      "Answer Faithfulness_explanation": "The AI assistant's answer is a concise and accurate description of Ramp's API. It provides a clear explanation of what the API does and how developers can use it to integrate Ramp's financial services into their own applications. The answer is faithful to the provided context.",
                      "Number of words": 18,
                    },
                    userProperties: {
                      "user": "google-oauth2|111840237613341303366",
                    },
                  },
                ],
              });

              if (res.statusCode == 200) {
                // handle response
              }
            }


            run();
components:
  schemas:
    CreateEventRequest:
      type: object
      properties:
        project:
          type: string
          description: Project associated with the event
        source:
          type: string
          description: Source of the event - production, staging, etc
        event_name:
          type: string
          description: Name of the event
        event_type:
          type: string
          enum:
            - model
            - tool
            - chain
          description: Specify whether the event is of "model", "tool" or "chain" type
        event_id:
          type: string
          description: Unique id of the event, if not set, it will be auto-generated
        session_id:
          type: string
          description: >-
            Unique id of the session associated with the event, if not set, it
            will be auto-generated
        parent_id:
          type: string
          description: Id of the parent event if nested
        children_ids:
          type: array
          items:
            type: string
          description: Id of events that are nested within the event
        config:
          type: object
          additionalProperties: true
          description: >-
            Associated configuration JSON for the event - model name, vector
            index name, etc
        inputs:
          type: object
          additionalProperties: true
          description: Input JSON given to the event - prompt, chunks, etc
          properties:
            chat_history:
              type: array
              items:
                type: object
                additionalProperties: true
              description: Messages passed to the model
        outputs:
          type: object
          additionalProperties: true
          description: Final output JSON of the event
        error:
          type: string
          description: Any error description if event failed
        start_time:
          type: number
          description: UTC timestamp (in milliseconds) for the event start
        end_time:
          type: integer
          description: UTC timestamp (in milliseconds) for the event end
        duration:
          type: number
          description: How long the event took in milliseconds
        metadata:
          type: object
          additionalProperties: true
          description: Any system or application metadata associated with the event
        feedback:
          type: object
          additionalProperties: true
          description: Any user feedback provided for the event output
        metrics:
          type: object
          additionalProperties: true
          description: Any values computed over the output of the event
        user_properties:
          type: object
          additionalProperties: true
          description: Any user properties associated with the event
      required:
        - project
        - event_type
        - event_name
        - source
        - config
        - inputs
        - duration
      example:
        project: Simple RAG
        event_type: model
        event_name: Model Completion
        source: playground
        session_id: caf77ace-3417-4da4-944d-f4a0688f3c23
        event_id: 7f22137a-6911-4ed3-bc36-110f1dde6b66
        parent_id: caf77ace-3417-4da4-944d-f4a0688f3c23
        children_ids: []
        config:
          model: gpt-3.5-turbo
          version: v0.1
          provider: openai
          hyperparameters:
            temperature: 0
            top_p: 1
            max_tokens: 1000
            presence_penalty: 0
            frequency_penalty: 0
            stop: []
            'n': 1
          template:
            - role: system
              content: |-
                Answer the user's question only using provided context.

                Context: {{ context }}
            - role: user
              content: '{{question}}'
          type: chat
        inputs:
          context: Hello world
          question: What is in the context?
          chat_history:
            - role: system
              content: |-
                Answer the user's question only using provided context.

                Context: Hello world
            - role: user
              content: What is in the context?
        outputs:
          role: assistant
          content: Hello world
        error: null
        start_time: 1714978764301
        end_time: 1714978765301
        duration: 999.8056
        metadata:
          cost: 0.00008
          completion_tokens: 23
          prompt_tokens: 35
          total_tokens: 58
        feedback: {}
        metrics:
          Answer Faithfulness: 5
          Answer Faithfulness_explanation: >-
            The AI assistant's answer is a concise and accurate description of
            Ramp's API. It provides a clear explanation of what the API does and
            how developers can use it to integrate Ramp's financial services
            into their own applications. The answer is faithful to the provided
            context.
          Number of words: 18
        user_properties:
          user: google-oauth2|111840237613341303366
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````